import * as action from '../actions'

import thunk from 'redux-thunk';
import { useEffect, useState } from 'react';
import { applyMiddleware } from 'redux';
import { connect } from 'react-redux';
import { Link, Route, Router, Switch, Redirect } from 'react-router-dom';
import { history } from '../App';

const LoginForm = ({ loged, onLogin }) => {
    let [login, setLogin] = useState()
    let [password, setPassword] = useState()
    let [log, setLog] = useState()
  
    useEffect(() => {
      setLog(loged)
      if (log?.payload && localStorage.authToken) history.push('/player')
    }, [loged, log])
  
    return (
      <>
        <h1>Web-player</h1>
        <div>
          <h2>Log-in</h2>
          <input type="text" placeholder='Login' onChange={(e) => setLogin(e.target.value)} />
          <br />
          <input type="password" placeholder='Password' onChange={(e) => setPassword(e.target.value)} />
          <br />
          <small style={{ color: 'red' }}>{loged.status === 'REJECTED' || (loged.status === 'RESOLVED' && !loged.payload) ? 'invalid login or password' : ''}</small>
          <br />
          <button
            disabled={!password || !login}
            onClick={() => { onLogin(login, password) }}
          >Login</button>
          <p>- OR -</p>
          <Link to="/registration">Register new user</Link>
        </div>
      </>
    )
  }
  
export const LoginFormConnect = connect(state => ({ loged: state.promise.login || {} }), { onLogin: action.actionFullLogin })(LoginForm)